require 'thor'
require 'plist'
require_relative 'error_plist_generator'
require_relative 'color_plist_generator'

module KMQToolKitCodeGen

  class CodeGeneration < Thor

    # ---------------------------
    # Error plist code generation
    # ---------------------------
    desc "errorgen PLIST", "This will generate files based on the provided error plist"
    long_desc <<-EOF
    TODO
    EOF
    method_options :prefix => :string, :path => :string
    def errorgen( plist )
      prefix = options[:prefix] || ""
      base_path = options[:path] || "./"
      plist_hash = Plist::parse_xml(plist)

      generator = ErrorPlistGenerator.new plist_hash, prefix, base_path
      generator.generate_domain
      generator.generate_error_code
    end

    # ---------------------------
    # Color plist code generation
    # ---------------------------
    desc "colorgen PLIST", "This will generate files based on provided color plist"
    method_options :prefix => :string, :path => :string, :key => :string
    def colorgen(plist)
      prefix = options[:prefix] || ""
      base_path = options[:path] || "./"
      plist_key = options[:key] || ""
      plist_hash = plist_key.split(".").inject(Plist::parse_xml(plist)) { |hash, key| hash[key] }

      generator = ColorPlistGenerator.new plist_hash, prefix, base_path
      generator.generate_color_names
    end

  end

end
