require_relative 'helper'
require 'ostruct'

class ColorPlistGenerator
  attr_reader :plist_hash, :prefix, :base_path

  def initialize(plist_hash, prefix, base_path)
    @template_folder = File.expand_path('../../templates', __FILE__)
    @plist_hash = plist_hash
    @prefix = prefix
    @base_path = base_path
    check
  end

  def generate_color_names
    color_names = @plist_hash.keys.collect do |name|
      name.slice(0, 1).capitalize + name.slice(1..-1)
    end
    create_color_name_file(color_names, 'h')
    create_color_name_file(color_names, 'm')
  end

  def create_color_name_file(names, type)
    file_name = "UIColor+#{@prefix}ColorName.#{type}"
    template_path = "#{@template_folder}/UIColor+ColorName.#{type}.erb"
    absolute_file_path = "#{@base_path}/#{file_name}"
    variables = OpenStruct.new(names: names, prefix: @prefix)
    Helper.write_to_file(absolute_file_path, template_path, variables.instance_eval{ binding })
  end

  def check
    if !@plist_hash.is_a?(Hash)
      raise RuntimeError, "Invalid plist format"
    end
  end
end
